Index: issm/trunk/src/c/Bamgx/objects/Triangles.cpp
===================================================================
--- issm/trunk/src/c/Bamgx/objects/Triangles.cpp	(revision 3242)
+++ issm/trunk/src/c/Bamgx/objects/Triangles.cpp	(revision 3243)
@@ -3698,11 +3698,11 @@
 
 		/*construction of a random order*/
-		const Int4 PrimeNumber= AGoodNumberPrimeWith(nbv)  ;
+		const long PrimeNumber= AGoodNumberPrimeWith(nbv)  ;
 		//remainder of the division of rand() by nbvnew
-		Int4 k3 = rand()%nbvnew;
+		long k3 = rand()%nbvnew;
 		//loop over the new points
-		for (Int4 is3=0; is3<nbvnew; is3++){
-			register Int4 j=nbvold +(k3 = (k3+PrimeNumber)%nbvnew);
-			register Int4 i=nbvold+is3; 
+		for (long is3=0; is3<nbvnew; is3++){
+			register long j=nbvold +(k3 = (k3+PrimeNumber)%nbvnew);
+			register long i=nbvold+is3; 
 			ordre[i]= vertices + j;
 			ordre[i]->ReferenceNumber=i;
@@ -3710,5 +3710,5 @@
 
 		// for all the new point
-		Int4 iv=nbvold;
+		long iv=nbvold;
 		for (i=nbvold;i<nbv;i++){
 			Vertex &vi=*ordre[i];
@@ -3721,5 +3721,5 @@
 				// a good new point 
 				Vertex &vj = vertices[iv];
-				Int4  j=vj.ReferenceNumber; 
+				long  j=vj.ReferenceNumber; 
 				if (&vj!=ordre[j]){
 					throw ErrorException(__FUNCT__,exprintf("&vj!= ordre[j]"));
@@ -3762,5 +3762,5 @@
 	Edge **e= new (Edge* [Gh.nbe]);
 
-	Int4 i;
+	long i;
 	for ( i=0;i<Gh.nbe ; i++)
 	 e[i]=NULL;
@@ -3807,10 +3807,10 @@
 
 
-			Int4 nbqq = (nbt*3)/2;
-			DoubleAndInt4  *qq = new DoubleAndInt4[nbqq];
-
-			Int4 i,ij;
+			long nbqq = (nbt*3)/2;
+			DoubleAndInt4 *qq = new DoubleAndInt4[nbqq];
+
+			long i,ij;
 			int j;
-			Int4 k=0;
+			long k=0;
 			for (i=0;i<nbt;i++)
 			 for (j=0;j<3;j++)
@@ -3820,5 +3820,5 @@
 			HeapSort(qq,k);
 
-			Int4 kk=0;
+			long kk=0;
 			for (ij=0;ij<k;ij++) { 
 				i=qq[ij].i3j/3;
@@ -3845,13 +3845,13 @@
 /*}}}1*/
 /*FUNCTION Triangles::MaxSubDivision{{{1*/
-void  Triangles::MaxSubDivision(Real8 maxsubdiv) {
+void  Triangles::MaxSubDivision(double maxsubdiv) {
 	long int verbosity=0;
 
-	const  Real8 maxsubdiv2 = maxsubdiv*maxsubdiv;
+	const  double maxsubdiv2 = maxsubdiv*maxsubdiv;
 	if(verbosity>1) printf("   Limit the subdivision of a edges in the new mesh by %g\n",maxsubdiv);
 	// for all the edges 
 	// if the len of the edge is to long 
-	Int4 it,nbchange=0;    
-	Real8 lmax=0;
+	long it,nbchange=0;    
+	double lmax=0;
 	for (it=0;it<nbt;it++)
 	  {
@@ -3866,9 +3866,9 @@
 				R2 AB= (R2) v1-(R2) v0;
 				Metric M = v0;
-				Real8 l = M(AB,AB);
+				double l = M(AB,AB);
 				lmax = Max(lmax,l);
 				if(l> maxsubdiv2)
 				  { R2 AC = M.Orthogonal(AB);// the ortogonal vector of AB in M
-					Real8 lc = M(AC,AC);
+					double lc = M(AC,AC);
 					D2xD2 Rt(AB,AC);// Rt.x = AB , Rt.y = AC;
 					D2xD2 Rt1(Rt.inv());
@@ -3883,5 +3883,5 @@
 				if(l> maxsubdiv2)
 				  { R2 AC = M.Orthogonal(AB);// the ortogonal vector of AB in M
-					Real8 lc = M(AC,AC);
+					double lc = M(AC,AC);
 					D2xD2 Rt(AB,AC);// Rt.x = AB , Rt.y = AC;
 					D2xD2 Rt1(Rt.inv());
@@ -3911,6 +3911,6 @@
 			return Metric(ba,*edge.EdgeVertex(0),bb,*edge.EdgeVertex(1));}
 		else { // inside
-			Real8   aa[3];
-			Real8 s = deta[0]+deta[1]+deta[2];
+			double   aa[3];
+			double s = deta[0]+deta[1]+deta[2];
 			aa[0]=deta[0]/s;
 			aa[1]=deta[1]/s;
@@ -3929,10 +3929,10 @@
 
 		int i,j,k;
-		Int4 NbTSwap=0;
-		Int4 nbtold=nbt;
-		Int4 nbvold=nbv;
-		Int4 Headt=0;
-		Int4 next_t;
-		Int4* first_np_or_next_t=new Int4[nbtx];
+		long NbTSwap=0;
+		long nbtold=nbt;
+		long nbvold=nbv;
+		long Headt=0;
+		long next_t;
+		long* first_np_or_next_t=new long[nbtx];
 		Triangle* t=NULL;
 
@@ -4018,5 +4018,5 @@
 				TriangleAdjacent ta(s->t, EdgesVertexTriangle[s->vint][1]);
 				Triangle*        tbegin= (Triangle*) ta;
-				Int4 kt;
+				long kt;
 				do { 
 					kt = Number((Triangle*) ta);
@@ -4036,5 +4036,5 @@
 		delete []  first_np_or_next_t;
 
-		Int4 NbSwapf =0,NbSwp;
+		long NbSwapf =0,NbSwp;
 
 		NbSwp = NbSwapf;
@@ -4045,5 +4045,5 @@
 	/*}}}1*/
 /*FUNCTION Triangles::PreInit{{{1*/
-void Triangles::PreInit(Int4 inbvx) {
+void Triangles::PreInit(long inbvx) {
 	long int verbosity=0;
 
@@ -4103,7 +4103,7 @@
 	/*FUNCTION Triangles::ProjectOnCurve{{{1*/
 	GeometricalEdge*   Triangles::ProjectOnCurve( Edge & BhAB, Vertex &  vA, Vertex & vB,
-				Real8 theta,Vertex & R,VertexOnEdge &  BR,VertexOnGeom & GR) {
+				double theta,Vertex & R,VertexOnEdge &  BR,VertexOnGeom & GR) {
 		void *pA=0,*pB=0;
-		Real8 tA=0,tB=0;
+		double tA=0,tB=0;
 		R2 A=vA,B=vB;
 		Vertex * pvA=&vA, * pvB=&vB;
@@ -4166,10 +4166,10 @@
 		R2 AB=B-A;
 
-		Real8 cosE01AB = (( (R2) (*e)[1] - (R2) (*e)[0] ) , AB);
+		double cosE01AB = (( (R2) (*e)[1] - (R2) (*e)[0] ) , AB);
 		int kkk=0;
 		int sens = (cosE01AB>0) ? 1 : 0;
 
-		//   Real8 l=0; // length of the edge AB
-		Real8 abscisse = -1;
+		//   double l=0; // length of the edge AB
+		double abscisse = -1;
 
 		for (int cas=0;cas<2;cas++){
@@ -4180,6 +4180,6 @@
 			Vertex  *v0=pvA,*v1; 
 			Edge *neee,*eee;
-			Real8 lg =0; // length of the curve 
-			Real8 te0;
+			double lg =0; // length of the curve 
+			double te0;
 			// we suppose take the curve's abcisse 
 			for ( eee=e,iii=sens,te0=tA;
@@ -4194,10 +4194,10 @@
 					throw ErrorException(__FUNCT__,exprintf("!eee"));
 				}
-				Real8 lg0 = lg;
-				Real8 dp = LengthInterpole(v0->m,v1->m,(R2) *v1 - (R2) *v0);
+				double lg0 = lg;
+				double dp = LengthInterpole(v0->m,v1->m,(R2) *v1 - (R2) *v0);
 				lg += dp;
 				if (cas && abscisse <= lg) { // ok we find the geom edge 
-					Real8 sss  =   (abscisse-lg0)/dp;
-					Real8 thetab = te0*(1-sss)+ sss*iii;
+					double sss  =   (abscisse-lg0)/dp;
+					double thetab = te0*(1-sss)+ sss*iii;
 					if (thetab<0 || thetab>1){
 						throw ErrorException(__FUNCT__,exprintf("thetab<0 || thetab>1"));
@@ -4212,16 +4212,16 @@
 				 tB = iii;
 
-				Real8 lg0 = lg;
+				double lg0 = lg;
 				if (!eee){
 					throw ErrorException(__FUNCT__,exprintf("!eee"));
 				}
 				v1 = pvB;
-				Real8 dp = LengthInterpole(v0->m,v1->m,(R2) *v1 - (R2) *v0);
+				double dp = LengthInterpole(v0->m,v1->m,(R2) *v1 - (R2) *v0);
 				lg += dp;	
 				abscisse = lg*theta;
 				if (abscisse <= lg && abscisse >= lg0 ) // small optimisation we know the lenght because end
 				  { // ok we find the geom edge 
-					Real8 sss  =   (abscisse-lg0)/dp;
-					Real8 thetab = te0*(1-sss)+ sss*tB;
+					double sss  =   (abscisse-lg0)/dp;
+					double thetab = te0*(1-sss)+ sss*tB;
 					if (thetab<0 || thetab>1){
 						throw ErrorException(__FUNCT__,exprintf("thetab<0 || thetab>1"));
@@ -4321,7 +4321,7 @@
 	void Triangles::ReNumberingTheTriangleBySubDomain(bool justcompress) {
 		long int verbosity=0;
-		Int4 *renu= new Int4[nbt];
+		long *renu= new long[nbt];
 		register Triangle *t0,*t,*te=triangles+nbt;
-		register Int4 k=0,it,i,j;
+		register long k=0,it,i,j;
 
 		for ( it=0;it<nbt;it++) 
@@ -4334,5 +4334,5 @@
 			}
 			do { 
-				Int4 kt = Number(t);
+				long kt = Number(t);
 				if (kt<0 || kt >= nbt ){
 					throw ErrorException(__FUNCT__,exprintf("kt<0 || kt >= nbt"));
@@ -4387,10 +4387,10 @@
 	/*}}}1*/
 	/*FUNCTION Triangles::ReNumberingVertex{{{1*/
-	void Triangles::ReNumberingVertex(Int4 * renu) {
+	void Triangles::ReNumberingVertex(long * renu) {
 		// warning be carfull because pointeur
 		// from on mesh to over mesh 
 		//  --  so do ReNumbering a the beginning
 		Vertex * ve = vertices+nbv;
-		Int4 it,ie,i;
+		long it,ie,i;
 
 		for ( it=0;it<nbt;it++) 
@@ -4430,5 +4430,5 @@
 		// move the Vertices without a copy of the array 
 		// be carefull not trivial code 
-		Int4 j;
+		long j;
 		for ( it=0;it<nbv;it++) // for all sub cycles of the permutation renu
 		 if (renu[it] >= 0) // a new sub cycle
@@ -4461,5 +4461,5 @@
 	pmin =  vertices[0].r;
 	pmax =  vertices[0].r;
-	Int4 i;
+	long i;
 	for (i=0;i<nbv;i++) {
 		pmin.x = Min(pmin.x,vertices[i].r.x);
@@ -4511,6 +4511,6 @@
 /*FUNCTION Triangles::ShowRegulaty{{{1*/
 void  Triangles::ShowRegulaty() const {
-	const  Real8  sqrt32=sqrt(3.)*0.5; 
-	const Real8  aireKh=sqrt32*0.5;
+	const  double  sqrt32=sqrt(3.)*0.5; 
+	const double  aireKh=sqrt32*0.5;
 	D2  Beq(1,0),Heq(0.5,sqrt32);
 	D2xD2 Br(D2xD2(Beq,Heq).t());
@@ -4522,6 +4522,6 @@
 	double  alpha2=0;
 	double area=0,Marea=0;
-	// Real8 cf= Real8(coefIcoor);
-	// Real8 cf2= 6.*cf*cf;
+	// double cf= double(coefIcoor);
+	// double cf2= 6.*cf*cf;
 	int nt=0;
 	for (int it=0;it<nbt;it++)
@@ -4530,5 +4530,5 @@
 		 nt++;
 		 Triangle &K=triangles[it];
-		 Real8  area3= Area2((R2) K[0],(R2) K[1],(R2) K[2])/6.;
+		 double  area3= Area2((R2) K[0],(R2) K[1],(R2) K[2])/6.;
 		 area+= area3;
 		 D2xD2 B_Kt(K[0],K[1],K[2]);
@@ -4540,9 +4540,9 @@
 		 MatVVP2x2 VMK(MK);
 		 alpha2 = Max(alpha2,Max(VMK.lambda1/VMK.lambda2,VMK.lambda2/VMK.lambda1));
-		 Real8 betaK=0;
+		 double betaK=0;
 
 		 for (int j=0;j<3;j++)
 			{
-			 Real8 he= Norme2(R2(K[j],K[(j+1)%3]));
+			 double he= Norme2(R2(K[j],K[(j+1)%3]));
 			 hmin=Min(hmin,he);
 			 hmax=Max(hmax,he);
@@ -4576,9 +4576,9 @@
 void  Triangles::ShowHistogram() const {
 
-	const Int4 kmax=10;
-	const Real8 llmin = 0.5,llmax=2;
-	const Real8 lmin=log(llmin),lmax=log(llmax),delta= kmax/(lmax-lmin);
-	Int4 histo[kmax+1];
-	Int4 i,it,k, nbedges =0;
+	const long kmax=10;
+	const double llmin = 0.5,llmax=2;
+	const double lmin=log(llmin),lmax=log(llmax),delta= kmax/(lmax-lmin);
+	long histo[kmax+1];
+	long i,it,k, nbedges =0;
 	for (i=0;i<=kmax;i++) histo[i]=0;
 	for (it=0;it<nbt;it++)
@@ -4595,5 +4595,5 @@
 				 if ( !& vP || !&vQ) continue;
 				 R2 PQ = vQ.r - vP.r;
-				 Real8 l = log(LengthInterpole(vP,vQ,PQ));
+				 double l = log(LengthInterpole(vP,vQ,PQ));
 				 nbedges++;
 				 k = (int) ((l - lmin)*delta);
@@ -4618,5 +4618,5 @@
 /*}}}1*/
 /*FUNCTION Triangles::SmoothingVertex{{{1*/
-void Triangles::SmoothingVertex(int nbiter,Real8 omega ) { 
+void Triangles::SmoothingVertex(int nbiter,double omega ) { 
 	long int verbosity=0;
 	//  if quatree exist remove it end reconstruct
@@ -4626,5 +4626,5 @@
 	Triangle vide; // a triangle to mark the boundary vertex
 	Triangle   ** tstart= new Triangle* [nbv];
-	Int4 i,j,k;
+	long i,j,k;
 	//   attention si Background == Triangle alors on ne peut pas utiliser la rechech rapide 
 	if ( this == & BTh)
@@ -4641,6 +4641,6 @@
 	for (k=0;k<nbiter;k++)
 	  {
-		Int4 i,NbSwap =0;
-		Real8 delta =0;
+		long i,NbSwap =0;
+		double delta =0;
 		for ( i=0;i<nbv;i++)
 		 if (tstart[i] != &vide) // not a boundary vertex 
@@ -4658,5 +4658,5 @@
 /*}}}1*/
 /*FUNCTION Triangles::SmoothMetric{{{1*/
-void Triangles::SmoothMetric(Real8 raisonmax) { 
+void Triangles::SmoothMetric(double raisonmax) { 
 	long int verbosity=0;
 
@@ -4664,9 +4664,9 @@
 	if(verbosity > 1) printf("   Triangles::SmoothMetric raisonmax = %g\n",raisonmax);
 	ReMakeTriangleContainingTheVertex();
-	Int4 i,j,kch,kk,ip;
-	Int4 *first_np_or_next_t0 = new Int4[nbv];
-	Int4 *first_np_or_next_t1 = new Int4[nbv];
-	Int4 Head0 =0,Head1=-1;
-	Real8 logseuil= log(raisonmax);
+	long i,j,kch,kk,ip;
+	long *first_np_or_next_t0 = new long[nbv];
+	long *first_np_or_next_t1 = new long[nbv];
+	long Head0 =0,Head1=-1;
+	double logseuil= log(raisonmax);
 
 	for(i=0;i<nbv-1;i++)
@@ -4699,11 +4699,11 @@
 					}
 					R2 Aij = (R2) vj - (R2) vi;
-					Real8 ll =  Norme2(Aij);
+					double ll =  Norme2(Aij);
 					if (0) {  
-						Real8 hi = ll/vi.m(Aij);
-						Real8 hj = ll/vj.m(Aij);
+						double hi = ll/vi.m(Aij);
+						double hj = ll/vj.m(Aij);
 						if(hi < hj)
 						  {
-							Real8 dh=(hj-hi)/ll;
+							double dh=(hj-hi)/ll;
 							if (dh>logseuil) {
 								vj.m.IntersectWith(vi.m/(1 +logseuil*ll/hi));
@@ -4715,5 +4715,5 @@
 					else
 					  {
-						Real8 li = vi.m(Aij);
+						double li = vi.m(Aij);
 						if( vj.m.IntersectWith(vi.m/(1 +logseuil*li)) )
 						 if(first_np_or_next_t1[j]<0) // if the metrix change 
@@ -4742,5 +4742,5 @@
 		ReNumberingTheTriangleBySubDomain();
 		//int nswap =0;
-		const Int4 nfortria( choice ? 4 : 6);
+		const long nfortria( choice ? 4 : 6);
 		if(withBackground) 
 		  {
@@ -4751,29 +4751,29 @@
 		 BTh.SetVertexFieldOn();
 
-		Int4 newnbt=0,newnbv=0;
-		Int4 * kedge = 0;
-		Int4 newNbOfQuad=NbOfQuad;
-		Int4 * ksplit= 0, * ksplitarray=0;
-		Int4 kkk=0;
+		long newnbt=0,newnbv=0;
+		long * kedge = 0;
+		long newNbOfQuad=NbOfQuad;
+		long * ksplit= 0, * ksplitarray=0;
+		long kkk=0;
 		int ret =0;
 		if (nbvx<nbv+nbe) return 1;//   
 		// 1) create  the new points by spliting the internal edges 
 		// set the 
-		Int4 nbvold = nbv;
-		Int4 nbtold = nbt;
-		Int4 NbOutTold  = NbOutT;
-		Int4  NbEdgeOnGeom=0;
-		Int4 i;
+		long nbvold = nbv;
+		long nbtold = nbt;
+		long NbOutTold  = NbOutT;
+		long  NbEdgeOnGeom=0;
+		long i;
 
 		nbt = nbt - NbOutT; // remove all the  the ouside triangles 
-		Int4 nbtsave = nbt;
+		long nbtsave = nbt;
 		Triangle * lastT = triangles + nbt;
 		for (i=0;i<nbe;i++)
 		 if(edges[i].onGeometry) NbEdgeOnGeom++;
-		Int4 newnbe=nbe+nbe;
-		//  Int4 newNbVerticesOnGeomVertex=NbVerticesOnGeomVertex;
-		Int4 newNbVerticesOnGeomEdge=NbVerticesOnGeomEdge+NbEdgeOnGeom;
-		// Int4 newNbVertexOnBThVertex=NbVertexOnBThVertex;
-		Int4 newNbVertexOnBThEdge=withBackground ? NbVertexOnBThEdge+NbEdgeOnGeom:0;
+		long newnbe=nbe+nbe;
+		//  long newNbVerticesOnGeomVertex=NbVerticesOnGeomVertex;
+		long newNbVerticesOnGeomEdge=NbVerticesOnGeomEdge+NbEdgeOnGeom;
+		// long newNbVertexOnBThVertex=NbVertexOnBThVertex;
+		long newNbVertexOnBThEdge=withBackground ? NbVertexOnBThEdge+NbEdgeOnGeom:0;
 
 		// do allocation for pointeur to the geometry and background
@@ -4787,13 +4787,13 @@
 		//  memcpy(newedges,edges,sizeof(Edge)*nbe);
 		SetOfEdges4 * edge4= new SetOfEdges4(nbe,nbv);
-		Int4 k=nbv;
-		Int4 kk=0;
-		Int4 kvb = NbVertexOnBThEdge;
-		Int4 kvg = NbVerticesOnGeomEdge;
-		Int4 ie =0;
+		long k=nbv;
+		long kk=0;
+		long kvb = NbVertexOnBThEdge;
+		long kvg = NbVerticesOnGeomEdge;
+		long ie =0;
 		Edge ** edgesGtoB=0;
 		if (withBackground)
 		 edgesGtoB= BTh.MakeGeometricalEdgeToEdge();
-		Int4 ferr=0;
+		long ferr=0;
 		for (i=0;i<nbe;i++)
 		 newedges[ie].onGeometry=0;
@@ -4828,5 +4828,5 @@
 					;
 					// get the Info on background mesh 
-					Real8 s =        newVertexOnBThEdge[kvb];
+					double s =        newVertexOnBThEdge[kvb];
 					Vertex &  bv0  = newVertexOnBThEdge[kvb][0];
 					Vertex &  bv1  = newVertexOnBThEdge[kvb][1];
@@ -4878,6 +4878,6 @@
 
 
-		kedge = new Int4[3*nbt+1];
-		ksplitarray = new Int4[nbt+1];
+		kedge = new long[3*nbt+1];
+		ksplitarray = new long[nbt+1];
 		ksplit = ksplitarray +1; // because ksplit[-1] == ksplitarray[0]
 
@@ -4900,15 +4900,15 @@
 				const Vertex & v0 = t[VerticesOfTriangularEdge[j][0]];
 				const Vertex & v1 = t[VerticesOfTriangularEdge[j][1]];
-				Int4  ke =edge4->SortAndFind(Number(v0),Number(v1));
+				long  ke =edge4->SortAndFind(Number(v0),Number(v1));
 				if (ke>0) 
 				  {
-					Int4 ii = Number(tt);
+					long ii = Number(tt);
 					int  jj = ta;
-					Int4 ks = ke + nbvold;
+					long ks = ke + nbvold;
 					kedge[3*i+j] = ks;
 					if (ii<nbt) // good triangle
 					 kedge[3*ii+jj] = ks;
 					Vertex &A=vertices[ks];
-					Real8 aa,bb,cc,dd;
+					double aa,bb,cc,dd;
 					if ((dd=Area2(v0.r,v1.r,A.r)) >=0){
 						// warning PB roundoff error 
@@ -4951,10 +4951,10 @@
 				if ( kedge[3*i+j] < 0) 
 				  {
-					Int4  ke =edge4->SortAndFind(Number(v0),Number(v1));
+					long  ke =edge4->SortAndFind(Number(v0),Number(v1));
 					if (ke<0) // new 
 					  {
 						if (&tt) // internal triangles all the boundary 
 						  { // new internal edges 
-							Int4 ii = Number(tt);
+							long ii = Number(tt);
 							int  jj = ta;
 
@@ -5010,7 +5010,7 @@
 		for (i=0;i<nbtsave;i++){
 			int  nbmkadj=0;
-			Int4 mkadj [100];
+			long mkadj [100];
 			mkadj[0]=i;
-			Int4 kk=ksplit[i]/10;
+			long kk=ksplit[i]/10;
 			int  ke=(int) (ksplit[i]%10);
 			if (kk>=7 || kk<=0){
@@ -5140,5 +5140,5 @@
 									vertices[nbv].DirOfSearch =NoDirOfSearch;
 									//vertices[nbv].i = toI2(vertices[nbv].r);
-									Real8 a3[]={1./3.,1./3.,1./3.};
+									double a3[]={1./3.,1./3.,1./3.};
 									vertices[nbv].m = Metric(a3,v0->m,v1->m,v2->m);
 									Vertex * vc =  vertices +nbv++;
@@ -5158,5 +5158,5 @@
 			// save all the new triangles
 			mkadj[nbmkadj++]=i;
-			Int4 jj;
+			long jj;
 			if (t0.link) 
 			 for (jj=nbt;jj<kkk;jj++)
@@ -5201,5 +5201,5 @@
 		for (i=0;i<NbSubDomains;i++)
 		  { 
-			Int4 k = subdomains[i].edge- edges;
+			long k = subdomains[i].edge- edges;
 			subdomains[i].edge =  edges+2*k; // spilt all edge in 2 
 		  }
@@ -5242,9 +5242,9 @@
 	/*}}}1*/
 /*FUNCTION Triangles::SplitInternalEdgeWithBorderVertices{{{1*/
-Int4  Triangles::SplitInternalEdgeWithBorderVertices(){
-	Int4 NbSplitEdge=0;
+long  Triangles::SplitInternalEdgeWithBorderVertices(){
+	long NbSplitEdge=0;
 	SetVertexFieldOn();  
-	Int4 it;
-	Int4 nbvold=nbv;
+	long it;
+	long nbvold=nbv;
 	long int verbosity=2;
 	for (it=0;it<nbt;it++){
@@ -5273,8 +5273,8 @@
 	ReMakeTriangleContainingTheVertex();    
 	if (nbvold!=nbv){
-		Int4  iv = nbvold;
-		Int4 NbSwap = 0;
+		long  iv = nbvold;
+		long NbSwap = 0;
 		Icoor2 dete[3];  
-		for (Int4 i=nbvold;i<nbv;i++) {// for all the new point
+		for (long i=nbvold;i<nbv;i++) {// for all the new point
 			Vertex & vi = vertices[i];
 			vi.i = toI2(vi.r);
@@ -5311,14 +5311,14 @@
 /*}}}1*/
 /*FUNCTION Triangles::TriangleReferenceList{{{1*/
-Int4  Triangles::TriangleReferenceList(Int4* reft) const {
+long  Triangles::TriangleReferenceList(long* reft) const {
 	long int verbosity=0;
 	register Triangle *t0,*t;
-	register Int4 k=0, num;   
+	register long k=0, num;   
 
 	//initialize all triangles as -1 (outside)
-	for (Int4 it=0;it<nbt;it++) reft[it]=-1;
+	for (long it=0;it<nbt;it++) reft[it]=-1;
 
 	//loop over all subdomains
-	for (Int4 i=0;i<NbSubDomains;i++){ 
+	for (long i=0;i<NbSubDomains;i++){ 
 
 		//first triangle of the subdomain i
@@ -5591,8 +5591,8 @@
 	/*}}}1*/
 	/*FUNCTION AGoodNumberPrimeWith{{{1*/
-	Int4 AGoodNumberPrimeWith(Int4 n){
+	long AGoodNumberPrimeWith(long n){
 
 		//list of big prime numbers
-		const Int4 BigPrimeNumber[] ={ 567890359L,
+		const long BigPrimeNumber[] ={ 567890359L,
 			567890431L,  567890437L,  567890461L,  567890471L,
 			567890483L,  567890489L,  567890497L,  567890507L,
@@ -5600,6 +5600,6 @@
 
 		//initialize o and pi
-		Int4 o =0;
-		Int4 pi=BigPrimeNumber[1];
+		long o =0;
+		long pi=BigPrimeNumber[1];
 
 		//loop until BigPrimeNumber[i]==0 (end of BigPrimeNumber)
@@ -5607,8 +5607,8 @@
 
 			//compute r, rest of the remainder of the division of BigPrimeNumber[i] by n
-			Int4 r = BigPrimeNumber[i] % n;
+			long r = BigPrimeNumber[i] % n;
 
 			/*compute oo = min ( r , n-r , |n - 2r|, |n-3r|)*/
-			Int4 oo = Min(Min(r,n-r),Min(Abs(n-2*r),Abs(n-3*r)));
+			long oo = Min(Min(r,n-r),Min(Abs(n-2*r),Abs(n-3*r)));
 			if ( o < oo){
 				o=oo;
Index: issm/trunk/src/c/Bamgx/objects/Triangles.h
===================================================================
--- issm/trunk/src/c/Bamgx/objects/Triangles.h	(revision 3242)
+++ issm/trunk/src/c/Bamgx/objects/Triangles.h	(revision 3243)
@@ -38,26 +38,26 @@
 			Geometry & Gh;   // Geometry
 			Triangles & BTh; // Background Mesh Bth==*this =>no  background 
-			Int4 NbRef;      // counter of ref on the this class if 0 we can delete
-			Int4 nbvx,nbtx;  // nombre max  de sommets , de  triangles
-			Int4 nt,nbv,nbt,nbiv,nbe; // nb of legal triangles, nb of vertex, of triangles, of initial vertices, of edges with reference,
-			Int4 NbOfQuad;  // nb of quadrangle 
-			Int4 NbSubDomains;
-			Int4 NbOutT;    // Nb of oudeside triangle
-			Int4 NbOfTriangleSearchFind;
-			Int4 NbOfSwapTriangle;
+			long NbRef;      // counter of ref on the this class if 0 we can delete
+			long nbvx,nbtx;  // nombre max  de sommets , de  triangles
+			long nt,nbv,nbt,nbiv,nbe; // nb of legal triangles, nb of vertex, of triangles, of initial vertices, of edges with reference,
+			long NbOfQuad;  // nb of quadrangle 
+			long NbSubDomains;
+			long NbOutT;    // Nb of oudeside triangle
+			long NbOfTriangleSearchFind;
+			long NbOfSwapTriangle;
 			Vertex* vertices;
-			Int4 NbVerticesOnGeomVertex;
+			long NbVerticesOnGeomVertex;
 			VertexOnGeom * VerticesOnGeomVertex;
-			Int4 NbVerticesOnGeomEdge;
+			long NbVerticesOnGeomEdge;
 			VertexOnGeom * VerticesOnGeomEdge;
-			Int4 NbVertexOnBThVertex;
+			long NbVertexOnBThVertex;
 			VertexOnVertex *VertexOnBThVertex;
-			Int4 NbVertexOnBThEdge;
+			long NbVertexOnBThEdge;
 			VertexOnEdge *VertexOnBThEdge;
-			Int4 NbCrackedVertices;
-			Int4 NbCrackedEdges;
+			long NbCrackedVertices;
+			long NbCrackedEdges;
 			CrackedEdge *CrackedEdges;
 			R2 pmin,pmax;    // extrema
-			Real8 coefIcoor; // coef to integer Icoor1;
+			double coefIcoor; // coef to integer Icoor1;
 			Triangle* triangles;
 			Edge* edges; 
@@ -70,11 +70,11 @@
 			Triangles(BamgMesh* bamgmesh,BamgOpts* bamgopts);
 			Triangles(double* index,double* x,double* y,int nods,int nels);
-			Triangles(Triangles &,Geometry * pGh=0,Triangles* pBTh=0,Int4 nbvxx=0 ); //copy operator
+			Triangles(Triangles &,Geometry * pGh=0,Triangles* pBTh=0,long nbvxx=0 ); //copy operator
 			Triangles(const Triangles &,const int *flag,const int *bb,BamgOpts* bamgopts); // truncature
-			Triangles(Int4 nbvx,Triangles & BT,BamgOpts* bamgopts,int keepBackVertices=1) :Gh(BT.Gh),BTh(BT) {
+			Triangles(long nbvx,Triangles & BT,BamgOpts* bamgopts,int keepBackVertices=1) :Gh(BT.Gh),BTh(BT) {
 				try {GeomToTriangles1(nbvx,bamgopts,keepBackVertices);}
 				catch(...) { this->~Triangles(); throw; }
 			}
-			Triangles(Int4 nbvx,Geometry & G,BamgOpts* bamgopts) :Gh(G),BTh(*this){
+			Triangles(long nbvx,Geometry & G,BamgOpts* bamgopts) :Gh(G),BTh(*this){
 				try { GeomToTriangles0(nbvx,bamgopts);}
 				catch(...) { this->~Triangles(); throw; }
@@ -83,13 +83,13 @@
 
 			//Operators
-			const Vertex & operator[]  (Int4 i) const { return vertices[i];};
-			Vertex & operator[](Int4 i) { return vertices[i];};
-			const Triangle & operator()  (Int4 i) const { return triangles[i];};
-			Triangle & operator()(Int4 i) { return triangles[i];};
+			const Vertex & operator[]  (long i) const { return vertices[i];};
+			Vertex & operator[](long i) { return vertices[i];};
+			const Triangle & operator()  (long i) const { return triangles[i];};
+			Triangle & operator()(long i) { return triangles[i];};
 
 			//Methods
 			void SetIntCoor(const char * from =0);
-			Real8 MinimalHmin() {return 2.0/coefIcoor;}
-			Real8 MaximalHmax() {return Max(pmax.x-pmin.x,pmax.y-pmin.y);}
+			double MinimalHmin() {return 2.0/coefIcoor;}
+			double MaximalHmax() {return Max(pmax.x-pmin.x,pmax.y-pmin.y);}
 			I2 toI2(const R2 & P) const {
 				return  I2( (Icoor1) (coefIcoor*(P.x-pmin.x))
@@ -103,33 +103,33 @@
 			void Renumber(BamgOpts* bamgopts);
 			void FindSubDomain(int OutSide=0);
-			Int4 TriangleReferenceList(Int4 *) const;
+			long TriangleReferenceList(long *) const;
 			void ShowHistogram() const;
 			void ShowRegulaty() const;
 			void ReMakeTriangleContainingTheVertex();
 			void UnMarkUnSwapTriangle();
-			void SmoothMetric(Real8 raisonmax) ;
-			void BoundAnisotropy(Real8 anisomax,double hminaniso= 1e-100) ;
-			void MaxSubDivision(Real8 maxsubdiv);
+			void SmoothMetric(double raisonmax) ;
+			void BoundAnisotropy(double anisomax,double hminaniso= 1e-100) ;
+			void MaxSubDivision(double maxsubdiv);
 			Edge** MakeGeometricalEdgeToEdge();
 			void SetVertexFieldOn();  
 			void SetVertexFieldOnBTh();
-			Int4 SplitInternalEdgeWithBorderVertices();
+			long SplitInternalEdgeWithBorderVertices();
 			void MakeQuadrangles(double costheta);
 			int  SplitElement(int choice);
 			void MakeQuadTree();
 			void NewPoints(Triangles &,BamgOpts* bamgopts,int KeepVertices=1);
-			Int4 InsertNewPoints(Int4 nbvold,Int4 & NbTSwap) ; 
+			long InsertNewPoints(long nbvold,long & NbTSwap) ; 
 			void ReNumberingTheTriangleBySubDomain(bool justcompress=false);
-			void ReNumberingVertex(Int4 * renu);
-			void SmoothingVertex(int =3,Real8=0.3);
+			void ReNumberingVertex(long * renu);
+			void SmoothingVertex(int =3,double=0.3);
 			Metric MetricAt (const R2 &) const;
-			GeometricalEdge* ProjectOnCurve( Edge & AB, Vertex &  A, Vertex & B,Real8 theta, Vertex & R,VertexOnEdge & BR,VertexOnGeom & GR);
-			Int4 Number(const Triangle & t) const  { return &t - triangles;}
-			Int4 Number(const Triangle * t) const  { return t - triangles;}
-			Int4 Number(const Vertex & t) const  { return &t - vertices;}
-			Int4 Number(const Vertex * t) const  { return t - vertices;}
-			Int4 Number(const Edge & t) const  { return &t - edges;}
-			Int4 Number(const Edge * t) const  { return t - edges;}
-			Int4 Number2(const Triangle * t) const  {
+			GeometricalEdge* ProjectOnCurve( Edge & AB, Vertex &  A, Vertex & B,double theta, Vertex & R,VertexOnEdge & BR,VertexOnGeom & GR);
+			long Number(const Triangle & t) const  { return &t - triangles;}
+			long Number(const Triangle * t) const  { return t - triangles;}
+			long Number(const Vertex & t) const  { return &t - vertices;}
+			long Number(const Vertex * t) const  { return t - vertices;}
+			long Number(const Edge & t) const  { return &t - edges;}
+			long Number(const Edge * t) const  { return t - edges;}
+			long Number2(const Triangle * t) const  {
 				return t - triangles;
 			}
@@ -139,5 +139,5 @@
 			void ReadMesh(BamgMesh* bamgmesh, BamgOpts* bamgopts);
 			void WriteMesh(BamgMesh* bamgmesh,BamgOpts* bamgopts);
-			void ReadMetric(BamgOpts* bamgopts,const Real8 hmin,const Real8 hmax,const Real8 coef);
+			void ReadMetric(BamgOpts* bamgopts,const double hmin,const double hmax,const double coef);
 			void WriteMetric(BamgOpts* bamgopts);
 			void AddMetric(BamgOpts* bamgopts);
@@ -153,7 +153,7 @@
 
 		private:
-			void GeomToTriangles1(Int4 nbvx,BamgOpts* bamgopts,int KeepVertices=1);// the real constructor mesh adaption
-			void GeomToTriangles0(Int4 nbvx,BamgOpts* bamgopts);// the real constructor mesh generator
-			void PreInit(Int4);
+			void GeomToTriangles1(long nbvx,BamgOpts* bamgopts,int KeepVertices=1);// the real constructor mesh adaption
+			void GeomToTriangles0(long nbvx,BamgOpts* bamgopts);// the real constructor mesh generator
+			void PreInit(long);
 
 	};
Index: issm/trunk/src/c/Bamgx/objects/Vertex.cpp
===================================================================
--- issm/trunk/src/c/Bamgx/objects/Vertex.cpp	(revision 3242)
+++ issm/trunk/src/c/Bamgx/objects/Vertex.cpp	(revision 3243)
@@ -14,5 +14,5 @@
 	/*Methods*/
 	/*FUNCTION Vertex::Smoothing{{{1*/
-	Real8  Vertex::Smoothing(Triangles &Th,const Triangles &BTh,Triangle* &tstart ,Real8 omega){
+	double  Vertex::Smoothing(Triangles &Th,const Triangles &BTh,Triangle* &tstart ,double omega){
 
 		register Vertex* s=this;
@@ -30,5 +30,5 @@
 
 				R2 Q = vQ,QP(P-Q);
-				Real8 lQP = LengthInterpole(vP,vQ,QP);
+				double lQP = LengthInterpole(vP,vQ,QP);
 				PNew += Q+QP/Max(lQP,1e-20);
 				kk ++;
@@ -43,8 +43,8 @@
 		} while ( tbegin != tria); 
 		if (kk<4) return 0;
-		PNew = PNew/(Real8)kk;
+		PNew = PNew/(double)kk;
 		R2 Xmove((PNew-P)*omega);
 		PNew = P+Xmove;
-		Real8 delta=Norme2_2(Xmove); 
+		double delta=Norme2_2(Xmove); 
 
 		Icoor2 deta[3];
@@ -60,6 +60,6 @@
 		}
 		else { // inside
-			Real8   aa[3];
-			Real8 s = deta[0]+deta[1]+deta[2];
+			double   aa[3];
+			double s = deta[0]+deta[1]+deta[2];
 			aa[0]=deta[0]/s;
 			aa[1]=deta[1]/s;
@@ -90,7 +90,7 @@
 					  {
 						vP = vPsave;
-						Real8 qold =QuadQuality(*v0,*v1,*v2,*v3);
+						double qold =QuadQuality(*v0,*v1,*v2,*v3);
 						vP = vPnew;
-						Real8 qnew =QuadQuality(*v0,*v1,*v2,*v3);
+						double qnew =QuadQuality(*v0,*v1,*v2,*v3);
 						if (qnew<qold) ok = 1;
 					  }
Index: issm/trunk/src/c/Bamgx/objects/Vertex.h
===================================================================
--- issm/trunk/src/c/Bamgx/objects/Vertex.h	(revision 3242)
+++ issm/trunk/src/c/Bamgx/objects/Vertex.h	(revision 3243)
@@ -25,10 +25,10 @@
 			R2 r;  // real coordinates
 			Metric m;
-			Int4 ReferenceNumber;
+			long ReferenceNumber;
 			Direction DirOfSearch;
 			short vint;  // the vertex number in triangle; varies between 0 and 2 in t
 			union {
 				Triangle* t; // one triangle which is containing the vertex
-				Int4 color;
+				long color;
 				Vertex* to;  // use in geometry Vertex to now the Mesh Vertex associed 
 				VertexOnGeom* onGeometry;       // if vint == 8; // set with Triangles::SetVertexFieldOn()
@@ -41,8 +41,8 @@
 			operator  const R2 & () const {return r;}    // Cast operator
 			operator Metric () const {return m;}         // Cast operator
-			Real8 operator()(R2 x) const { return m(x);} // Get x in the metric m
+			double operator()(R2 x) const { return m(x);} // Get x in the metric m
 
 			//methods (No constructor and no destructors...)
-			Real8 Smoothing(Triangles & ,const Triangles & ,Triangle  * & ,Real8 =1);
+			double Smoothing(Triangles & ,const Triangles & ,Triangle  * & ,double =1);
 			void  MetricFromHessian(const double Hxx,const double Hyx, const double Hyy, const double smin,const double smax,const double s,const double err,BamgOpts* bamgopts);
 			void  Echo();
@@ -50,5 +50,5 @@
 
 			//inline functions
-			inline Int4 Optim(int =1,int =0); 
+			inline long Optim(int =1,int =0); 
 			inline void Set(const Vertex & rec,const Triangles &,Triangles &);
 	};
Index: issm/trunk/src/c/Bamgx/objects/VertexOnEdge.h
===================================================================
--- issm/trunk/src/c/Bamgx/objects/VertexOnEdge.h	(revision 3242)
+++ issm/trunk/src/c/Bamgx/objects/VertexOnEdge.h	(revision 3243)
@@ -21,12 +21,12 @@
 			Vertex* v;
 			Edge*   be;
-			Real8 abcisse;
+			double abcisse;
 
 			//Constructors
-			VertexOnEdge( Vertex * w, Edge *bw,Real8 s) :v(w),be(bw),abcisse(s) {}
+			VertexOnEdge( Vertex * w, Edge *bw,double s) :v(w),be(bw),abcisse(s) {}
 			VertexOnEdge(){}
 
 			//Operators
-			operator Real8 () const { return abcisse;}
+			operator double () const { return abcisse;}
 			operator Vertex* () const { return v;}  
 			operator Edge* () const { return be;}  
@@ -37,5 +37,5 @@
 
 			//Inline methods
-			inline void Set(const Triangles &,Int4,Triangles &);  
+			inline void Set(const Triangles &,long,Triangles &);  
 	};
 
Index: issm/trunk/src/c/Bamgx/objects/VertexOnGeom.h
===================================================================
--- issm/trunk/src/c/Bamgx/objects/VertexOnGeom.h	(revision 3242)
+++ issm/trunk/src/c/Bamgx/objects/VertexOnGeom.h	(revision 3243)
@@ -22,5 +22,5 @@
 
 			Vertex* mv;
-			Real8 abscisse;  
+			double abscisse;  
 			union{ 
 				GeometricalVertex * gv; // if abscisse <0; 
@@ -31,5 +31,5 @@
 			VertexOnGeom(): mv(0),abscisse(0){gv=0;} 
 			VertexOnGeom(Vertex & m,GeometricalVertex &g) : mv(&m),abscisse(-1){gv=&g;}
-			VertexOnGeom(Vertex & m,GeometricalEdge &g,Real8 s) : mv(&m),abscisse(s){ge=&g;}
+			VertexOnGeom(Vertex & m,GeometricalEdge &g,double s) : mv(&m),abscisse(s){ge=&g;}
 
 			//Operators
@@ -37,5 +37,5 @@
 			operator GeometricalVertex * () const  {return gv;}
 			operator GeometricalEdge * () const  {return ge;}
-			operator const Real8 & () const {return abscisse;}
+			operator const double & () const {return abscisse;}
 
 			//Methods
@@ -46,5 +46,5 @@
 
 			//Inline methods
-			inline void Set(const Triangles &,Int4,Triangles &);
+			inline void Set(const Triangles &,long,Triangles &);
 			inline void Set(const VertexOnGeom&,const Triangles &,Triangles &);  
 
Index: issm/trunk/src/c/Bamgx/objects/VertexOnVertex.h
===================================================================
--- issm/trunk/src/c/Bamgx/objects/VertexOnVertex.h	(revision 3242)
+++ issm/trunk/src/c/Bamgx/objects/VertexOnVertex.h	(revision 3243)
@@ -29,5 +29,5 @@
 
 			//Inline methods
-			inline void Set(const Triangles &,Int4,Triangles &);
+			inline void Set(const Triangles &,long,Triangles &);
 	};
 
